# OgreGpuProgram.h File Reference

`#include "OgrePrerequisites.h"`
`#include "OgreResource.h"`
`#include "OgreSharedPtr.h"`
`#include "OgreIteratorWrappers.h"`

Go to the source code of this file.

## Namespaces

namespace | Ogre

## Classes

struct | Ogre::GpuConstantDefinition
| Information about predefined program constants. More...
struct | Ogre::GpuNamedConstants
| Struct collecting together the information for named constants. More...
struct | Ogre::GpuLogicalIndexUse
| Structure recording the use of a physical buffer by a logical parameter index. More...
struct | Ogre::GpuLogicalBufferStruct
| Container struct to allow params to safely & update shared list of logical buffer assignments. More...
class | Ogre::GpuProgramParameters
| Collects together the program parameters used for a GpuProgram. More...
struct | Ogre::GpuProgramParameters::AutoConstantDefinition
| Structure defining an auto constant that's available for use in a parameters object. More...
class | Ogre::GpuProgramParameters::AutoConstantEntry
| Structure recording the use of an automatic parameter. More...
class | Ogre::GpuProgram
| Defines a program which runs on the GPU such as a vertex or fragment program. More...
class | Ogre::GpuProgram::CmdType
| Command object - see ParamCommand. More...
class | Ogre::GpuProgram::CmdSyntax
class | Ogre::GpuProgram::CmdSkeletal
class | Ogre::GpuProgram::CmdMorph
class | Ogre::GpuProgram::CmdPose
class | Ogre::GpuProgram::CmdVTF
class | Ogre::GpuProgramPtr
| Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr. More...

## Typedefs

typedef std::map < String, GpuConstantDefinition > | Ogre::GpuConstantDefinitionMap
typedef ConstMapIterator < GpuConstantDefinitionMap > | Ogre::GpuConstantDefinitionIterator
typedef std::map < size_t, GpuLogicalIndexUse > | Ogre::GpuLogicalIndexUseMap
typedef SharedPtr < GpuProgramParameters > | Ogre::GpuProgramParametersSharedPtr
| Shared pointer used to hold references to GpuProgramParameters instances.

## Enumerations

enum | Ogre::GpuProgramType { Ogre::GPT_VERTEX_PROGRAM, Ogre::GPT_FRAGMENT_PROGRAM }
| Enumerates the types of programs which can run on the GPU. More...

enum

Ogre::GpuConstantType {
Ogre::GCT_FLOAT1, Ogre::GCT_FLOAT2, Ogre::GCT_FLOAT3, Ogre::GCT_FLOAT4,
Ogre::GCT_SAMPLER1D, Ogre::GCT_SAMPLER2D, Ogre::GCT_SAMPLER3D, Ogre::GCT_SAMPLERCUBE,
Ogre::GCT_SAMPLER1DSHADOW, Ogre::GCT_SAMPLER2DSHADOW, Ogre::GCT_MATRIX_2X2, Ogre::GCT_MATRIX_2X3,
Ogre::GCT_MATRIX_2X4, Ogre::GCT_MATRIX_3X2, Ogre::GCT_MATRIX_3X3, Ogre::GCT_MATRIX_3X4,
Ogre::GCT_MATRIX_4X2, Ogre::GCT_MATRIX_4X3, Ogre::GCT_MATRIX_4X4, Ogre::GCT_INT1,
Ogre::GCT_INT2, Ogre::GCT_INT3, Ogre::GCT_INT4, Ogre::GCT_UNKNOWN
}

| Enumeration of the types of constant we may encounter in programs. More...

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sat May 10 16:25:05 2008